<template>
  <div>
    <template v-if="computedActionsListItems.length > 0">
      <a
        v-for="(action, index) in computedActionsListItems"
        :key="index"
        @click.stop="action.method(item)"
      >
        {{ action.title }}
      </a>
    </template>
    <template v-if="computedActionsMenuItems.length > 0">
      <v-menu v-model="active" offset-y>
        <template v-slot:activator="{ on }">
          <v-btn class="font-weight-bold" large text icon v-on="on">
            <v-icon class="menu-icon" :class="{ active: active }"
              >mdi-dots-horizontal</v-icon
            >
          </v-btn>
        </template>
        <v-list>
          <v-list-item
            v-for="(action, index) in computedActionsMenuItems"
            :key="index"
            @click="action.method(item)"
          >
            <v-list-item-title>{{ action.title }}</v-list-item-title>
          </v-list-item>
          <v-list-item
            v-for="(action, index) in item.actions"
            :key="index"
            @click="action.method(item)"
          >
            <v-list-item-title>{{ action.title }}</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </template>
  </div>
</template>
<script>
export default {
  props: {
    item: {
      type: Object,
      default: () => []
    },
    actions: {
      type: Array,
      default: () => []
    }
  },
  data() {
    return {
      active: false
    };
  },
  computed: {
    computedActionsMenuItems() {
      return this.actions.filter(action => action.display == "menu");
    },
    computedActionsListItems() {
      return this.actions.filter(action => action.display == "list");
    }
  }
};
</script>
<style scoped>
.menu-icon.active {
  transform: rotateZ(90deg);
}
.menu-icon {
  transform: rotateZ(0deg);
}
</style>
